SystemOrganization addCategory: #'PolySource-Core'!
SystemOrganization addCategory: #'PolySource-Model'!
SystemOrganization addCategory: #'PolySource-Tests'!

SqEntity subclass: #PSClient
	instanceVariableNames: 'snapshot updates'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Model'!

!PSClient methodsFor: 'accessing' stamp: 'mt 8/30/2010 13:31:34.438'!
addUpdate: aCodeUpdate

	self updates add: aCodeUpdate.
	dummy := #snapshotUpdated.
	self snapshotUpdated: aCodeUpdate.! !

!PSClient methodsFor: 'accessing' stamp: 'mt 8/30/2010 13:26:57.291'!
snapshot

	^ snapshot! !

!PSClient methodsFor: 'accessing' stamp: 'mt 8/30/2010 13:28:08.404'!
snapshot: aCodeSnapshot

	snapshot := aCodeSnapshot.
	self snapshotChanged.! !

!PSClient methodsFor: 'signals' stamp: 'mt 8/30/2010 13:28:01.047'!
snapshotChanged

	self emit.! !

!PSClient methodsFor: 'signals' stamp: 'mt 8/30/2010 13:31:16.622'!
snapshotUpdated: anUpdate

	self emit.! !

!PSClient methodsFor: 'accessing' stamp: 'mt 8/30/2010 13:29:16.047'!
updates

	^ updates ifNil: [updates := OrderedCollection new]! !

SqEntity subclass: #PSCodeRepository
	instanceVariableNames: 'clients'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Model'!

!PSCodeRepository methodsFor: 'add/remove' stamp: 'mt 8/30/2010 13:22:48.261'!
addClient: aClient

	self clients add: aClient.
	dummy := #clientAdded.
	^ aClient! !

!PSCodeRepository methodsFor: 'accessing' stamp: 'mt 8/30/2010 13:15:34.996'!
clients

	^ clients ifNil: [clients := OrderedCollection new]! !

!PSCodeRepository methodsFor: 'add/remove' stamp: 'mt 8/30/2010 13:23:45.497'!
removeClient: aClient

	self clients remove: aClient ifAbsent: [].
	dummy := #clientRemoved.
	^ aClient! !

!Morph methodsFor: '*polysource-core-override' stamp: 'mt 8/29/2010 19:52:30.277'!
handleEvent: anEvent
	"Handle the given event"

	"((PSFixtures includesKey: #example01) and: 
		[(PSCurrentSystemDictionary value isNil and: [self boundsInWorld left > (DisplayScreen actualScreenSize x / 2)])]) ifTrue: [
		PSCurrentSystemDictionary value: (PSFixtures at: #example01) during: [^anEvent sentTo: self]]."
	
	^anEvent sentTo: self! !

!Morph methodsFor: '*polysource-core-override' stamp: 'mt 8/29/2010 19:52:36.426'!
processEvent: anEvent using: defaultDispatcher
	"This is the central entry for dispatching events in morphic. Given some event and a default dispatch strategy, find the right receiver and let him handle it.
	WARNING: This is a powerful hook. If you want to use a different event dispatcher from the default, here is the place to hook it in. Depending on how the dispatcher is written (e.g., whether it calls simply #processEvent: or #processEvent:using:) you can change the dispatch strategy for entire trees of morphs. Similarly, you can disable entire trees of morphs from receiving any events whatsoever. Read the documentation in class MorphicEventDispatcher before playing with it. "
	(self rejectsEvent: anEvent) ifTrue:[^#rejected].
	
	"((PSFixtures includesKey: #example01) and: 
		[(PSCurrentSystemDictionary value isNil and: [self boundsInWorld left > (DisplayScreen actualScreenSize x / 2)])]) ifTrue: [
		PSCurrentSystemDictionary value: (PSFixtures at: #example01) during: [^defaultDispatcher dispatchEvent: anEvent with: self]]."

	^defaultDispatcher dispatchEvent: anEvent with: self! !

Dictionary subclass: #PSFixtures
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Tests'!

PSFixtures class
	instanceVariableNames: 'instance'!

PSFixtures class
	instanceVariableNames: 'instance'!

!PSFixtures class methodsFor: 'accessing' stamp: 'mig 8/9/2010 17:30:19.665'!
at: key

	^ self instance at: key! !

!PSFixtures class methodsFor: 'accessing' stamp: 'mig 8/9/2010 17:30:01.619'!
at: key put: value
.
	^ self instance at: key put: value! !

!PSFixtures class methodsFor: 'examples' stamp: 'mt 8/29/2010 19:45:22.874'!
example01

	"Need a proxy to get the class compiled into the right dictionary."
	PSSystemDictionaryProxy install.

	PSCurrentSystemDictionary
		value: (PSFixtures at: #example01 put: PSSystemDictionary new)
		during: [Object
			subclass: #PSFoobar
			instanceVariableNames: ''
			classVariableNames: ''
			poolDictionaries: ''
			category: 'PolySource-Tests-Temporary'].

	"Test data prepared. Clean up."
	Smalltalk globals uninstall.! !

!PSFixtures class methodsFor: 'testing' stamp: 'mig 8/25/2010 13:53:39.589'!
includesKey: key

	^ self instance includesKey: key! !

!PSFixtures class methodsFor: 'singleton' stamp: 'mig 8/9/2010 17:29:05.257'!
instance

	^ instance ifNil: [instance := self new]! !

DynamicVariable subclass: #PSDynamicVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Core'!

PSDynamicVariable subclass: #PSCurrentSystemDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Core'!

!PSCurrentSystemDictionary commentStamp: 'mt 8/29/2010 19:24:56.7' prior: 0!
I am used to perform the correct class lookup in the PSSystemDictionaryProxy.!

PSDynamicVariable subclass: #PSCurrentSystemOrganizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Core'!

!PSDynamicVariable class methodsFor: 'scope' stamp: 'mt 8/30/2010 13:03:51.756'!
values: someVariableValueAssociations during: aBlock
	"Example:
	
	PSDynamicVariable
		values: {PSCurrentSystemDictionary -> myDict. PSCurrentSystemOrganizer -> myOrga}
		during: myBlock"
	
	someVariableValueAssociations
		ifEmpty: [^ aBlock value].
	
	^ self
		values: someVariableValueAssociations allButFirst
		during: [someVariableValueAssociations first key
			value: someVariableValueAssociations first value
			during: aBlock].! !

!SystemOrganizer methodsFor: '*polysource-core' stamp: 'mt 8/30/2010 11:30:34.255'!
isProxy

	^ false! !

SystemDictionary subclass: #PSSystemDictionary
	instanceVariableNames: 'organization'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Core'!

!PSSystemDictionary commentStamp: 'mt 8/29/2010 19:23:48.53' prior: 0!
I am a copy of the local SystemDictionary (Smalltalk globals) but I do not copy the classes. I provide my own organization.!

!PSSystemDictionary methodsFor: 'as yet unclassified' stamp: 'mig 8/9/2010 15:00:32.549'!
initialize: size

	super initialize: size.
	Smalltalk globals keysAndValuesDo: [ :key :value |
		self at: key put: value].! !

!PSSystemDictionary methodsFor: 'as yet unclassified' stamp: 'mig 8/9/2010 16:38:17.817'!
organization

	^ organization ifNil: [organization := SystemOrganization deepCopy]! !

!SystemDictionary methodsFor: '*polysource-core' stamp: 'mt 8/29/2010 19:32:52.227'!
isProxy

	^ false! !

TestCase subclass: #PSBasicTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Tests'!

!PSBasicTestCase methodsFor: 'tests' stamp: 'mig 8/9/2010 15:22:47.123'!
test01new

	| sut |
	sut := PSSystemDictionary new.

	self assert: sut size equals: Smalltalk globals size.
	Smalltalk globals keysAndValuesDo: [:key :value |
		self assert: value == (sut at: key)].
! !

!PSBasicTestCase methodsFor: 'tests' stamp: 'mig 8/10/2010 13:59:49.758'!
test02proxy

	| testCase sut root |
	
	sut := PSSystemDictionaryProxy new.
	root := Smalltalk globals.
	
	testCase := Smalltalk globals at: #TestCase.
	
	sut install.
	self assert: sut == Smalltalk globals.
	self assert: testCase == (Smalltalk globals at: #TestCase).
	sut uninstall.
	self assert: root == Smalltalk globals.! !

!PSBasicTestCase methodsFor: 'tests' stamp: 'mt 8/30/2010 11:55:22.347'!
test03proxyWithOrganization

	PSSystemDictionaryProxy install.
	
	self
		assert: Smalltalk globals isProxy;
		assert: SystemOrganization isProxy.
		
	PSSystemDictionaryProxy uninstall.
	
	self
		deny: Smalltalk globals isProxy;
		deny: SystemOrganization isProxy.! !

TestCase subclass: #PSProxiedTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Tests'!

!PSProxiedTestCase methodsFor: 'running' stamp: 'mt 8/29/2010 19:41:49.115'!
setUp

	super setUp.
	PSSystemDictionaryProxy install.! !

!PSProxiedTestCase methodsFor: 'running' stamp: 'mig 8/10/2010 14:00:41.469'!
tearDown

	Smalltalk globals uninstall.
	super tearDown.
! !

!PSProxiedTestCase methodsFor: 'tests' stamp: 'mig 8/10/2010 14:36:28.592'!
test01environment

	| newDictionary |
	newDictionary := PSSystemDictionary new.
	
	PSCurrentSystemDictionary value: newDictionary during: [
		self assert: Object environment yourself == newDictionary].
	self deny: Object environment yourself == newDictionary.
! !

!PSProxiedTestCase methodsFor: 'tests' stamp: 'mig 8/10/2010 15:25:52.941'!
test02newClasses

	self deny: (Smalltalk includesKey: #PSFoobar).
	self deny: (Smalltalk includesKey: #PSFoobar2).
	
	PSCurrentSystemDictionary value: PSSystemDictionary new during: [
		"Create a class and a subclass of it."
		Object subclass: #PSFoobar instanceVariableNames: '' classVariableNames: '' poolDictionaries: '' category: 'PolySource-Tests-Temporary'.
		(Smalltalk at: #PSFoobar)
			subclass: #PSFoobar2 instanceVariableNames: '' classVariableNames: '' poolDictionaries: '' category: 'PolySource-Tests-Temporary'.
		self assert: (Smalltalk includesKey: #PSFoobar).
		self assert: (Smalltalk includesKey: #PSFoobar2)].
	
	self deny: (Smalltalk includesKey: #PSFoobar).
	self deny: (Smalltalk includesKey: #PSFoobar2).
! !

!PSProxiedTestCase methodsFor: 'tests' stamp: 'mt 8/29/2010 19:39:08.882'!
test03evaluate

	self deny: (Smalltalk includesKey: #PSFoobar).
	
	PSCurrentSystemDictionary value: PSSystemDictionary new during: [
		"Create a class and instantiate it once."
		Object subclass: #PSFoobar instanceVariableNames: '' classVariableNames: '' poolDictionaries: '' category: 'PolySource-Tests-Temporary'.
		self
			shouldnt: [Compiler evaluate: 'PSFoobar new']
			raise: MessageNotUnderstood].
		
	self
		should: [Compiler evaluate: 'PSFoobar new']
		raise: MessageNotUnderstood.
! !

!PSProxiedTestCase methodsFor: 'tests' stamp: 'mt 8/29/2010 19:56:47.815'!
test05proxyTest

	PSSystemDictionaryProxy uninstall.
	self deny: Smalltalk globals isProxy.

	PSSystemDictionaryProxy install.
	self assert: Smalltalk globals isProxy.! !

!PSProxiedTestCase methodsFor: 'tests' stamp: 'mig 8/10/2010 17:12:06.726'!
testXXX04browser

	self deny: (Smalltalk includesKey: #PSFoobar).
	
	PSCurrentSystemDictionary value: PSSystemDictionary new during: [
		"Create a class and instantiate it once."
		Object subclass: #PSFoobar instanceVariableNames: '' classVariableNames: '' poolDictionaries: '' category: 'PolySource-Tests-Temporary'.
		Compiler evaluate: 'Browser openBrowserView: ((Browser systemOrganizer: Smalltalk organization) openEditString: nil) label: ''TestBrowser'''.
		].
! !

!Class methodsFor: '*polysource-core-override' stamp: 'mig 8/9/2010 16:23:00.596'!
environment

	^ Smalltalk globals
	"environment == nil ifTrue: [^ super environment].
	^ environment"! !

ProtoObject subclass: #PSSystemDictionaryProxy
	instanceVariableNames: 'original'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Core'!

!PSSystemDictionaryProxy class methodsFor: 'installation' stamp: 'mig 8/9/2010 17:42:02.667'!
install

	self new install.! !

!PSSystemDictionaryProxy class methodsFor: 'installation' stamp: 'mig 8/9/2010 17:42:35.209'!
uninstall

	Smalltalk globals uninstall.! !

!PSSystemDictionaryProxy methodsFor: 'proxy' stamp: 'mig 8/9/2010 17:48:24.671'!
doesNotUnderstand: aMessage

	original ifNil: [^ super doesNotUnderstand: aMessage].
	
	^ aMessage sendTo: (PSCurrentSystemDictionary value ifNil: [original])! !

!PSSystemDictionaryProxy methodsFor: 'installation' stamp: 'mt 8/30/2010 11:49:01.349'!
install

	self isInstalled ifTrue: [^self].

	original := Smalltalk globals.
	Smalltalk instVarNamed: #globals put: self.
	
	"Add a proxy for the organization too."
	PSSystemOrganizerProxy install.
! !

!PSSystemDictionaryProxy methodsFor: 'testing' stamp: 'mig 8/9/2010 15:14:19.08'!
isInstalled

	^ Smalltalk globals == self! !

!PSSystemDictionaryProxy methodsFor: 'testing' stamp: 'mt 8/29/2010 19:32:19.736'!
isProxy

	^ true! !

!PSSystemDictionaryProxy methodsFor: 'installation' stamp: 'mt 8/30/2010 11:49:48.948'!
uninstall

	self isInstalled ifFalse: [^self].

	Smalltalk instVarNamed: #globals put: original.
	original := nil.
	
	"Remove proxy for organization."
	PSSystemOrganizerProxy uninstall.! !

ProtoObject subclass: #PSSystemOrganizerProxy
	instanceVariableNames: 'original'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PolySource-Core'!

!PSSystemOrganizerProxy commentStamp: 'mt 8/30/2010 11:52:21.467' prior: 0!
DO NOT install me directly but use "PSSystemDictionaryProxy install" instead.!

!PSSystemOrganizerProxy class methodsFor: 'as yet unclassified' stamp: 'mt 8/30/2010 11:37:54.726'!
install

	self new install.! !

!PSSystemOrganizerProxy class methodsFor: 'as yet unclassified' stamp: 'mt 8/30/2010 11:38:13.074'!
uninstall

	SystemOrganization uninstall.! !

!PSSystemOrganizerProxy methodsFor: 'as yet unclassified' stamp: 'mt 8/30/2010 11:27:05.986'!
doesNotUnderstand: aMessage

	original ifNil: [^ super doesNotUnderstand: aMessage].
	
	^ aMessage sendTo: (PSCurrentSystemOrganizer value ifNil: [original])! !

!PSSystemOrganizerProxy methodsFor: 'as yet unclassified' stamp: 'mt 8/30/2010 11:37:01.302'!
install

	self isInstalled ifTrue: [^self].

	original := SystemOrganization.
	Smalltalk at: #SystemOrganization put: self.
! !

!PSSystemOrganizerProxy methodsFor: 'as yet unclassified' stamp: 'mt 8/30/2010 11:37:27.065'!
isInstalled

	^ SystemOrganization == self! !

!PSSystemOrganizerProxy methodsFor: 'as yet unclassified' stamp: 'mt 8/30/2010 11:29:56.853'!
isProxy

	^ true! !

!PSSystemOrganizerProxy methodsFor: 'as yet unclassified' stamp: 'mt 8/30/2010 11:37:15.148'!
uninstall

	self isInstalled ifFalse: [^self].
	
	Smalltalk at: #SystemOrganization put: original.
	original := nil.! !
